"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.elementWithAuth = void 0;
var router_1 = require("next/router");
var react_1 = __importDefault(require("react"));
var elementWithAuth = function (Component, state) {
    var Permissions = function () {
        if (!state.userData)
            return react_1.default.createElement(react_1.default.Fragment, null);
        // If user is logged in, return original component
        return react_1.default.createElement(Component, null);
    };
    return Permissions;
};
exports.elementWithAuth = elementWithAuth;
var pageWithAuth = function (Component, state) {
    var Auth = function () {
        var router = (0, router_1.useRouter)();
        var isWindowDefined = typeof window !== "undefined";
        // If user is not logged in, return an empty component and push to login page
        if (!state.userData && isWindowDefined) {
            router.push("/login");
            return react_1.default.createElement(react_1.default.Fragment, null);
        }
        // If user is logged in, return original component
        return react_1.default.createElement(Component, null);
    };
    // Copy getInitial props so it will run as well
    if (Component.getInitialProps) {
        Auth.getInitialProps = Component.getInitialProps;
    }
    return Auth;
};
exports.default = pageWithAuth;
