var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { SupportedApiMethods } from "../interfaces/generics";
import { getCookie } from "cookies-next";
/// Global api request class. Use this to put any api request through
var ApiRequest = /** @class */ (function () {
    function ApiRequest() {
        var _this = this;
        this.requestHeaders = function (additionalHeaders) {
            var _a;
            var token = getCookie("token");
            var headers = {
                "content-type": "application/json",
                Authorization: (_a = "Bearer ".concat(token)) !== null && _a !== void 0 ? _a : undefined,
                accept: "application/json",
            };
            if (!!additionalHeaders) {
                headers = __assign(__assign({}, headers), additionalHeaders);
            }
            return headers;
        };
        this.getResponse = function (response) { return __awaiter(_this, void 0, void 0, function () {
            var json, data, breadCrumbs;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, response.json()];
                    case 1:
                        json = _a.sent();
                        data = response.status < 400 ? json["data"] : json;
                        breadCrumbs = response.status < 400 ? json["breadcrumbs"] : json;
                        return [2 /*return*/, {
                                data: data,
                                breadCrumbs: breadCrumbs,
                                statusCode: response.status,
                            }];
                }
            });
        }); };
        this.createRequest = function (method, endpoint, payload, additionalHeaders) { return __awaiter(_this, void 0, void 0, function () {
            var headers, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        headers = this.requestHeaders(additionalHeaders);
                        return [4 /*yield*/, fetch(
                            // `http://127.0.0.1:8000/api${endpoint}`,
                            "https://api.staging.gamespace.gg/api".concat(endpoint), {
                                method: method,
                                body: payload,
                                headers: headers,
                            })];
                    case 1:
                        response = _a.sent();
                        return [4 /*yield*/, this.getResponse(response)];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        this.get = function (endpoint, additionalHeaders) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.createRequest(SupportedApiMethods.GET, endpoint, undefined, additionalHeaders)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        this.put = function (endpoint, payload, additionalHeaders) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.createRequest(SupportedApiMethods.PUT, endpoint, payload, additionalHeaders)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        this.post = function (endpoint, payload, additionalHeaders) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.createRequest(SupportedApiMethods.POST, endpoint, payload, additionalHeaders)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        this.delete = function (endpoint, payload, additionalHeaders) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.createRequest(SupportedApiMethods.DELETE, endpoint, payload, additionalHeaders)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        this.patch = function (endpoint, payload, additionalHeaders) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.createRequest(SupportedApiMethods.PATCH, endpoint, payload, additionalHeaders)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
    }
    return ApiRequest;
}());
export { ApiRequest };
